$ NOPRINT ERRORPRINT
NAME MATCH1B
;*******************************************************************
;*******************************************************************
;                            MATCHE.ASM
;                      running boar rifle match
;                        support routines (2)
;*******************************************************************
;*******************************************************************
;
;*******************************************************************
;                          p u b l i c s 
;*******************************************************************
; Labels and procedures
PUBLIC  VRI_ON
PUBLIC  VRI_OFF
PUBLIC  MOUSE_BUT
PUBLIC  SCOPE_OFF
;
;*******************************************************************
;                         e x t e r n a l s 
;*******************************************************************
; Externals from other modules
EXTRN   ON_X:           ABS
;
;EXTRN   AR_BYTE:        BYTE
;EXTRN   NEW_RUN:        BYTE
;EXTRN   BOAR_SPEED:     BYTE
;EXTRN   BOAR_OFF:       BYTE
;EXTRN   NEW_RUN:        BYTE
;EXTRN   FIRST_DUCK:     BYTE
;
; Code externals from SOLUTIONS.LIB and from other modules
EXTRN   KBR_FLUSH:      FAR
EXTRN   KBR_STATUS:     FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   SOUND:          FAR
EXTRN   RANDOM_NUM:     FAR
EXTRN   BIN_TO_ASC:     FAR
EXTRN   BIO_SET_MODE:   FAR
EXTRN   COARSE_FILL:    FAR
EXTRN   COARSE_ADD:     FAR
EXTRN   SET_WRITE_MODE: FAR
EXTRN   DATA_XOR:       FAR
EXTRN   DATA_NORMAL:    FAR
EXTRN   START_MAIN:     FAR
EXTRN   MILLI_TIME:     FAR
EXTRN   PIXEL_ADD:      FAR
EXTRN   WRITE_PIX:      FAR
EXTRN   FINE_TEXT:      FAR
EXTRN   COARSE_TEXT:    FAR
EXTRN   MULTI_TEXT:     FAR
EXTRN   SHOW_BIT_MAP:   FAR
;
;
;**************************** equates ******************************
;
;*****************************************************************
;                               data
;*****************************************************************
DATA    SEGMENT BYTE    PUBLIC
;***********************|
;    DS externals       |
;***********************|
EXTRN   FONT_1X16:      BYTE
EXTRN   ORIGIN_X:       WORD
EXTRN   ORIGIN_Y:       WORD
EXTRN   END_X:          WORD
EXTRN   END_Y:          WORD
EXTRN   LINE_COLOR:     BYTE
EXTRN   RUN_CNT:        BYTE
;
;
; Bit maps for left and right boars
; Block control area:                      Displacement -->
RTARGET DW      24          ; Present x coordinate         0
        DW      90          ; y coordinate                 2
        DB      19          ; Horizontal rows in block     4
        DB      6           ; Number of bytes per row      5
;
; Symbol encoding for right-hand boar
        DB      000H,00FH,0FFH,0F0H,001H,0F8H ; 1
        DB      000H,070H,081H,00FH,0C2H,000H ; 2
        DB      000H,081H,0BCH,080H,03CH,000H ; 3
        DB      003H,002H,042H,040H,002H,000H ; 4
        DB      00CH,004H,099H,020H,002H,000H ; 5
        DB      030H,005H,024H,0A0H,001H,000H ; 6
        DB      0C0H,005H,05AH,0A0H,001H,000H ; 7
        DB      080H,005H,05AH,0A0H,001H,000H ; 8
        DB      078H,005H,024H,0A0H,000H,0E0H ; 9
        DB      006H,004H,099H,020H,000H,010H ; 10
        DB      001H,0E2H,042H,040H,000H,010H ; 11
        DB      000H,011H,0BCH,080H,000H,008H ; 12
        DB      001H,0E0H,081H,000H,000H,014H ; 13
        DB      002H,000H,07EH,00FH,083H,0EAH ; 14
        DB      00DH,000H,03FH,0F0H,07CH,037H ; 15
        DB      006H,086H,040H,000H,000H,028H ; 16
        DB      000H,099H,080H,000H,000H,024H ; 17
        DB      001H,060H,000H,000H,000H,01EH ; 18
        DB      003H,080H,000H,000H,000H,000H ; 19
        DW      0000H
        DW      0000H
;
;****************************|
;    left-to-right boar      |
;****************************|
; Block control area:                           Displacement -->
LTARGET DW      24          ; Present x coordinate         0
        DW      90          ; y coordinate                 2
        DB      19          ; Horizontal rows in block     4
        DB      6           ; Number of bytes per row      5
;
; Symbol encoding for left-hand boar
        DB      01FH,080H,00FH,0FFH,0F0H,000H ; 1
        DB      000H,043H,0F0H,081H,00EH,000H ; 2
        DB      000H,03CH,001H,03CH,081H,000H ; 3
        DB      000H,040H,002H,042H,040H,0C0H ; 4
        DB      000H,040H,004H,099H,020H,030H ; 5
        DB      000H,080H,005H,024H,0A0H,00CH ; 6
        DB      000H,080H,005H,05AH,0A0H,003H ; 7
        DB      000H,080H,005H,05AH,0A0H,001H ; 8
        DB      007H,000H,005H,024H,0A0H,01EH ; 9
        DB      008H,000H,004H,099H,020H,060H ; 10
        DB      008H,000H,002H,042H,047H,080H ; 11
        DB      010H,000H,001H,03CH,088H,000H ; 12
        DB      028H,000H,000H,081H,007H,080H ; 13
        DB      05FH,0C1H,0F0H,03FH,000H,040H ; 14
        DB      0FCH,03EH,00FH,0FCH,000H,0B0H ; 15
        DB      014H,000H,000H,002H,061H,060H ; 16
        DB      024H,000H,000H,001H,099H,000H ; 17
        DB      078H,000H,000H,000H,006H,080H ; 18
        DB      000H,000H,000H,000H,001H,0C0H ; 19
        DW      0000H
        DW      0000H
;
TARGET_COLOR    DB      00000100B       ; I R G B code
;
TARGET_BOX      DW      12          ; Present x coordinate
                DW      72          ; y coordinate                 2
                DW      8
                DW      8
                DB      00000000B       ; Color code
        DB      0DAH,0C4H,0D0H,0C4H,0C4H,0C4H,0D0H,0C4H,0BFH,0FFH
        DB      0B3H,020H,020H,020H,020H,020H,020H,020H,0B3H,0FFH
        DB      0B3H,020H,020H,020H,020H,020H,020H,020H,0B3H,0FFH
        DB      0B3H,020H,020H,020H,020H,020H,020H,020H,0B3H,0FFH
        DB      0B3H,020H,020H,020H,020H,020H,020H,020H,0B3H,0FFH
        DB      0C0H,0C4H,0C4H,0C4H,0C4H,0C4H,0C4H,0C4H,0D9H,000H
        DW      0
;
SCOPE_MAP1      DW      104         ; Start x coordinate
                DW      140         ; Start y coordinate
                DB      64          ; Number of pixel rows
                DB      8           ; Number of columns (bytes)
; 1
        DB      000H,07EH,000H,000H,000H,000H,000H,000H  ; 1 
        DB      001H,0FFH,000H,000H,000H,000H,000H,000H  ; 2 
        DB      003H,0FFH,080H,000H,000H,000H,000H,000H  ; 3 
        DB      007H,0FFH,0C0H,000H,000H,000H,000H,000H  ; 4 
        DB      00FH,0FFH,0F0H,000H,000H,000H,000H,000H  ; 5 
        DB      00FH,0FFH,0F8H,000H,000H,000H,000H,000H  ; 6 
        DB      01FH,0FFH,01CH,000H,000H,000H,000H,000H  ; 7 
        DB      01FH,0FFH,07FH,000H,000H,000H,000H,000H  ; 8 
; 2
        DB      03FH,0FCH,0E0H,000H,000H,000H,000H,000H  ; 1 
        DB      03FH,0F9H,080H,000H,000H,000H,000H,000H  ; 2 
        DB      03FH,0F7H,000H,000H,000H,000H,000H,000H  ; 3 
        DB      03FH,0F6H,000H,000H,000H,000H,000H,000H  ; 4 
        DB      03FH,0FCH,000H,000H,000H,000H,000H,000H  ; 5 
        DB      03FH,0FCH,000H,000H,000H,000H,000H,000H  ; 6 
        DB      01FH,0FCH,000H,000H,000H,000H,000H,000H  ; 7 
        DB      00FH,0F0H,000H,000H,000H,000H,000H,000H  ; 8 
; 3
        DB      007H,0F0H,000H,000H,000H,000H,000H,000H  ; 1 
        DB      003H,0F0H,000H,000H,000H,000H,000H,000H  ; 2 
        DB      001H,0F0H,000H,000H,000H,000H,000H,000H  ; 3 
        DB      000H,0F0H,000H,000H,000H,000H,000H,000H  ; 4 
        DB      000H,070H,000H,000H,000H,000H,000H,000H  ; 5 
        DB      000H,030H,000H,000H,000H,000H,000H,000H  ; 6 
        DB      000H,010H,000H,000H,000H,000H,000H,000H  ; 7 
        DB      000H,000H,000H,000H,000H,000H,000H,000H  ; 8 
; 4
        DB      000H,000H,000H,000H,000H,000H,000H,000H  ; 1 
        DB      000H,000H,000H,000H,000H,000H,000H,000H  ; 2 
        DB      000H,000H,000H,000H,000H,000H,000H,000H  ; 3 
        DB      000H,000H,018H,000H,000H,000H,000H,000H  ; 4 
        DB      000H,000H,01EH,000H,000H,000H,000H,000H  ; 5 
        DB      000H,000H,01FH,080H,000H,000H,000H,000H  ; 6 
        DB      000H,000H,007H,0E0H,000H,000H,000H,000H  ; 7 
        DB      000H,000H,001H,0F8H,000H,000H,000H,000H  ; 8 
; 5
        DB      000H,000H,000H,0FEH,000H,000H,000H,070H  ; 1 
        DB      000H,000H,000H,0FFH,080H,001H,0F0H,0C8H  ; 2 
        DB      000H,000H,000H,0FFH,0C0H,003H,0F9H,0E4H  ; 3 
        DB      000H,000H,001H,0FFH,000H,003H,0FDH,0BCH  ; 4 
        DB      000H,000H,003H,0FFH,080H,007H,0FFH,0DCH  ; 5 
        DB      000H,000H,003H,0FCH,0C0H,007H,0FFH,0F8H  ; 6 
        DB      000H,000H,003H,0FCH,060H,00FH,0FFH,0E0H  ; 7 
        DB      000H,000H,003H,0FCH,030H,00FH,0FFH,0C0H  ; 8 
; 6
        DB      000H,000H,003H,0FCH,018H,007H,0FFH,080H  ; 1 
        DB      000H,000H,003H,0FCH,00CH,000H,000H,000H  ; 2 
        DB      000H,000H,007H,0FEH,006H,000H,000H,000H  ; 3 
        DB      000H,000H,00EH,077H,003H,000H,000H,000H  ; 4 
        DB      000H,000H,01CH,063H,081H,080H,000H,000H  ; 5 
        DB      000H,000H,038H,061H,0C0H,0C0H,000H,000H  ; 6 
        DB      000H,000H,070H,060H,0E0H,000H,000H,000H  ; 7 
        DB      000H,000H,0E0H,060H,070H,000H,000H,000H  ; 8 
; 7
        DB      000H,001H,0C0H,060H,038H,000H,000H,000H  ; 1 
        DB      000H,003H,080H,060H,01CH,000H,000H,000H  ; 2 
        DB      000H,007H,000H,060H,00EH,000H,000H,000H  ; 3 
        DB      000H,00EH,000H,060H,007H,000H,000H,000H  ; 4 
        DB      000H,01CH,000H,060H,003H,080H,000H,000H  ; 5 
        DB      000H,038H,000H,060H,001H,0C0H,000H,000H  ; 6 
        DB      000H,070H,000H,060H,000H,0E0H,000H,000H  ; 7 
        DB      000H,0E0H,000H,060H,000H,070H,000H,000H  ; 8 
; 8
        DB      001H,0C0H,000H,000H,000H,038H,000H,000H  ; 1 
        DB      003H,080H,000H,000H,000H,01CH,000H,000H  ; 2 
        DB      007H,000H,000H,000H,000H,00EH,000H,000H  ; 3 
        DB      00EH,000H,000H,000H,000H,007H,000H,000H  ; 4 
        DB      01CH,000H,000H,000H,000H,003H,080H,000H  ; 5 
        DB      038H,000H,000H,000H,000H,001H,0C0H,000H  ; 6 
        DB      070H,000H,000H,000H,000H,000H,0E0H,000H  ; 7 
        DB      0E0H,000H,000H,000H,000H,000H,070H,000H  ; 8 
        DW      0
;
;
SCOPE_MAP2      DW      112         ; Start x coordinate
                DW      148         ; Start y coordinate
                DB      48          ; Number of pixel rows
                DB      6           ; Number of columns (bytes)
; 1
        DB      000H,01FH,000H,000H,000H,000H  ; 1 
        DB      000H,07FH,0C0H,000H,000H,000H  ; 2 
        DB      000H,0FFH,0E0H,000H,000H,000H  ; 3 
        DB      001H,0FFH,0F0H,000H,000H,000H  ; 4 
        DB      003H,0FFH,0F8H,000H,000H,000H  ; 5 
        DB      007H,0FFH,0FCH,000H,000H,000H  ; 6 
        DB      007H,0FFH,0FEH,000H,000H,000H  ; 7 
        DB      00FH,0FFH,0FFH,000H,000H,000H  ; 8 
;
; 2
        DB      00FH,0FFH,0FFH,080H,000H,000H  ; 1 
        DB      00FH,0FFH,0FFH,0C0H,000H,000H  ; 2 
        DB      00FH,0FFH,0FFH,0E0H,000H,000H  ; 3 
        DB      00FH,0FFH,0FFH,0F0H,000H,000H  ; 4 
        DB      00FH,0FFH,0FFH,0F8H,000H,000H  ; 5 
        DB      00FH,0FFH,0FFH,0FCH,000H,000H  ; 6 
        DB      00FH,0FFH,0FFH,0FEH,000H,000H  ; 7 
        DB      00FH,0FFH,0FFH,0FFH,080H,000H  ; 8 
;
; 3
        DB      001H,0FFH,0FFH,0FFH,0C0H,000H  ; 1 
        DB      000H,07FH,0FFH,0FFH,0E0H,000H  ; 2 
        DB      000H,01FH,0FFH,0FFH,0F0H,000H  ; 3 
        DB      000H,007H,0FFH,0FFH,0F8H,000H  ; 4 
        DB      000H,001H,0FFH,0FFH,0FCH,000H  ; 5 
        DB      000H,000H,07FH,0FFH,0FEH,000H  ; 6 
        DB      000H,000H,01FH,0FFH,0FFH,000H  ; 7 
        DB      000H,000H,007H,0FFH,0FFH,080H  ; 8 
; 4
        DB      000H,000H,001H,0FFH,0FFH,0C0H  ; 1 
        DB      000H,000H,000H,07FH,0FEH,000H  ; 2 
        DB      000H,000H,000H,03FH,0FCH,000H  ; 3 
        DB      000H,000H,000H,01FH,0FCH,000H  ; 4 
        DB      000H,000H,000H,001H,0F8H,000H  ; 5 
        DB      000H,000H,000H,000H,0F8H,000H  ; 6 
        DB      000H,000H,000H,000H,070H,000H  ; 7 
        DB      000H,000H,000H,000H,010H,000H  ; 8 
; 5
        DB      000H,000H,000H,000H,000H,000H  ; 1 
        DB      000H,000H,000H,000H,000H,000H  ; 2 
        DB      000H,000H,000H,000H,000H,000H  ; 3 
        DB      000H,000H,000H,000H,000H,000H  ; 4 
        DB      000H,000H,000H,000H,038H,000H  ; 5 
        DB      000H,000H,000H,000H,03CH,000H  ; 6 
        DB      000H,000H,000H,000H,0FEH,000H  ; 7 
        DB      000H,000H,000H,000H,0FFH,000H  ; 8 
; 6
        DB      000H,000H,000H,000H,07FH,080H  ; 1 
        DB      000H,000H,000H,000H,03FH,0C0H  ; 2 
        DB      000H,000H,000H,000H,01FH,0C0H  ; 3 
        DB      000H,000H,000H,000H,00FH,080H  ; 4 
        DB      000H,000H,000H,000H,007H,000H  ; 5 
        DB      000H,000H,000H,000H,000H,000H  ; 6 
        DB      000H,000H,000H,000H,000H,000H  ; 7 
        DB      000H,000H,000H,000H,000H,000H  ; 8 
;
;
; Bit map for black color in ammo box
AMMO_MAP1       DW      60          ; Start x coordinate
                DW      176         ; Start y coordinate
                DB      32          ; Number of pixel rows
                DB      3           ; Number of columns (bytes)
; 1
        DB      000H,080H,000H  ; 1
        DB      001H,040H,000H  ; 2
        DB      002H,020H,000H  ; 3
        DB      004H,010H,000H  ; 4
        DB      008H,008H,000H  ; 5
        DB      010H,004H,000H  ; 6
        DB      020H,002H,000H  ; 7
        DB      040H,001H,000H  ; 8
; 2
        DB      080H,000H,080H  ; 1
        DB      0C0H,000H,040H  ; 2
        DB      0A0H,000H,020H  ; 3
        DB      090H,000H,010H  ; 4
        DB      088H,000H,030H  ; 5
        DB      084H,000H,048H  ; 6
        DB      082H,000H,084H  ; 7
        DB      081H,001H,002H  ; 8
; 3
        DB      040H,082H,001H  ; 1
        DB      020H,044H,001H  ; 2
        DB      010H,048H,003H  ; 3
        DB      008H,010H,005H  ; 4
        DB      004H,018H,009H  ; 5
        DB      002H,014H,011H  ; 6
        DB      001H,012H,021H  ; 7
        DB      000H,091H,041H  ; 8
; 4
        DB      000H,050H,081H  ; 1
        DB      000H,030H,082H  ; 2
        DB      000H,010H,084H  ; 3
        DB      000H,008H,088H  ; 4
        DB      000H,004H,090H  ; 5
        DB      000H,002H,0A0H  ; 6
        DB      000H,001H,0C0H  ; 7
        DB      000H,000H,080H  ; 8
        DW      0
;
; Bit map for green color in ammo box
AMMO_MAP2       DW      60          ; Start x coordinate
                DW      176         ; Start y coordinate
                DB      25          ; Number of pixel rows
                DB      3           ; Number of columns (bytes)
;
; 1
        DB      000H,000H,000H  ; 1
        DB      000H,080H,000H  ; 2
        DB      001H,0C0H,000H  ; 3
        DB      003H,0E0H,000H  ; 4
        DB      007H,0F0H,000H  ; 5
        DB      00DH,0F8H,000H  ; 6
        DB      01BH,07CH,000H  ; 7
        DB      026H,0BEH,000H  ; 8
; 2
        DB      06CH,07FH,000H  ; 1
        DB      036H,0FFH,080H  ; 2
        DB      05EH,0DFH,0C0H  ; 3
        DB      06EH,0AFH,0E0H  ; 4
        DB      077H,05FH,0C0H  ; 5
        DB      01BH,095H,080H  ; 6
        DB      05DH,0FFH,000H  ; 7
        DB      06EH,0E3H,000H  ; 8
; 3
        DB      037H,07CH,000H  ; 1
        DB      01BH,0B8H,000H  ; 2
        DB      00EH,0D0H,000H  ; 3
        DB      007H,0E0H,000H  ; 4
        DB      003H,020H,000H  ; 5
        DB      001H,080H,000H  ; 6
        DB      000H,0E0H,000H  ; 7
        DB      000H,060H,000H  ; 8
; 4
        DB      000H,020H,000H  ; 1
        DW      0
;
; Bit map for yellow color in ammo box
AMMO_MAP3       DW      60          ; Start x coordinate
                DW      176         ; Start y coordinate
                DB      24          ; Number of pixel rows
                DB      3           ; Number of columns (bytes)
;
; 1
        DB      000H,000H,000H  ; 1
        DB      000H,000H,000H  ; 2
        DB      000H,000H,000H  ; 3
        DB      000H,000H,000H  ; 4
        DB      000H,000H,000H  ; 5
        DB      002H,000H,000H  ; 6
        DB      004H,080H,000H  ; 7
        DB      019H,040H,000H  ; 8
;
; 2
        DB      00BH,080H,000H  ; 1
        DB      005H,000H,000H  ; 2
        DB      001H,020H,000H  ; 3
        DB      001H,050H,000H  ; 4
        DB      000H,0A0H,000H  ; 5
        DB      060H,06AH,010H  ; 6
        DB      020H,010H,018H  ; 7
        DB      010H,01CH,060H  ; 8
;
; 3
        DB      008H,000H,060H  ; 1
        DB      004H,001H,080H  ; 2
        DB      001H,001H,080H  ; 3
        DB      000H,006H,060H  ; 4
        DB      000H,0C6H,060H  ; 5
        DB      000H,061H,080H  ; 6
        DB      000H,001H,080H  ; 7
        DB      000H,000H,000H  ; 8
        DW      0
;
; Map for small grass
LITTLE_GRASS    DW      96          ; Start x coordinate
                DW      120         ; Start y coordinate
                DB      4           ; Number of pixel rows
                DB      10          ; Number of columns (bytes)
;
        DB      49H,49H,49H,49H,49H,49H,49H,49H,49H,49H
        DB      0DBH,0DBH,0DBH,0DBH,0DBH,0DBH,0DBH,0DBH,0DBH,0DBH
        DB      0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
        DB      0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
        DW      0
;
; Colors in I R G B encoding
BLACK   DB      00000000B
RED     DB      00000100B
YELLOW  DB      00001110B
GREEN   DB      00000010B
;
DATA    ENDS
;
;*****************************************************************
;                               code
;*****************************************************************
CODE_1  SEGMENT BYTE   PUBLIC
        ASSUME  CS:CODE_1,DS:DATA
;**********************|
;    CS externals      |
;**********************|
EXTRN   OLD_VECTOR_0A:  DWORD
EXTRN   BRESENHAM:      NEAR    ; In MATCH1A.ASM
EXTRN   VARI_MAP:       NEAR    ; In MATCH1A.ASM
;
EXTRN   CRT_PORT:       WORD
EXTRN   OLD_VRE:        BYTE
EXTRN   ACTIVE_BOAR:    BYTE
EXTRN   RPIG_X:         WORD
EXTRN   RPIG_Y:         WORD
EXTRN   LPIG_X:         WORD
EXTRN   LPIG_Y:         WORD
EXTRN   CROSS_X:        WORD
EXTRN   CROSS_Y:        WORD
EXTRN   GUN_LOADED:     BYTE
EXTRN   HIT_SW:         BYTE
EXTRN   GUN_FIRED:      BYTE
EXTRN   X_VALUE:        BYTE
EXTRN   Y_VALUE:        BYTE
EXTRN   GRASS_X:        WORD
EXTRN   GRASS_Y:        WORD
EXTRN   GRASS_COLOR:    BYTE
;
;*******************************************************************
;                            procedures
;*******************************************************************
SCOPE_OFF       PROC    NEAR
; Erase target area
        CALL    DATA_NORMAL
;**********************|
; clear display area   |
;**********************|
        MOV     CH,0            ; Start column
        MOV     CL,8            ; Start row
        MOV     DH,22           ; Horizontal bytes
        MOV     DL,21           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
;
; Display white target area
        MOV     CH,2            ; Start column
        MOV     CL,10           ; Start row
        MOV     DH,8            ; Horizontal bytes
        MOV     DL,5            ; Vertical bytes
        MOV     AL,00001111B    ; Color = white
        CALL    COARSE_FILL
; Display outside box for target
        LEA     SI,TARGET_BOX   ; Pointer to message text
        LEA     DI,FONT_1X16    ; Font to use
        CALL    MULTI_TEXT      ; Display routine
; Display boar according to program switches
        CMP     RUN_CNT,0       ; Is start of run ?
        JE      NO_BOAR
; Test ACTIVE_BOAR variable and select boar bit map
        LEA     SI,LTARGET      ; Offset of right boar bit map
        CMP     CS:ACTIVE_BOAR,'R' ; Test for right boar on
        JE      BOAR_DISPLAY    ; Display right boar
        LEA     SI,RTARGET      ; Change to left boar
BOAR_DISPLAY:
        LEA     BX,TARGET_COLOR ; Color
        CALL    SHOW_BIT_MAP
; Display horizontal target lines
NO_BOAR:
        MOV     ORIGIN_X,0 
        MOV     ORIGIN_Y,72
        MOV     END_X,176
        MOV     END_Y,72
        MOV     LINE_COLOR,00000000B    ; I R G B code
        CALL    BRESENHAM
;
        MOV     ORIGIN_X,0 
        MOV     ORIGIN_Y,136
        MOV     END_X,176
        MOV     END_Y,136
        MOV     LINE_COLOR,00000000B    ; I R G B code
        CALL    BRESENHAM
;
; Display dark gray area
        MOV     CH,12           ; Start column
        MOV     CL,10           ; Start row
        MOV     DH,10           ; Horizontal bytes
        MOV     DL,6            ; Vertical bytes
        MOV     AL,00001000B    ; Color = dark gray
        CALL    COARSE_FILL
;
; Display grass on gray area
        LEA     SI,LITTLE_GRASS ; Offset of bit map
        LEA     BX,GREEN        ; Color
        CALL    SHOW_BIT_MAP
;
; Display table
        MOV     ORIGIN_X,50
        MOV     ORIGIN_Y,172
        MOV     END_X,176
        MOV     END_Y,172
        MOV     LINE_COLOR,00000110B    ; I R G B code
        CALL    BRESENHAM
;
        ADD     ORIGIN_Y,4
        ADD     END_Y,4
        MOV     ORIGIN_X,47
        CALL    BRESENHAM
;
        ADD     ORIGIN_Y,8
        ADD     END_Y,8
        MOV     ORIGIN_X,43
        CALL    BRESENHAM
;
        ADD     ORIGIN_Y,12
        ADD     END_Y,12
        MOV     ORIGIN_X,36
        MOV     END_X,72
        CALL    BRESENHAM
;
        MOV     ORIGIN_X,83
        MOV     END_X,176
        CALL    BRESENHAM
;
; 30 degree line
        MOV     ORIGIN_X,50
        MOV     ORIGIN_Y,172
        MOV     END_X,24
        MOV     END_Y,216
        CALL    BRESENHAM
;
; Display edge of board
        MOV     CH,3            ; Start column
        MOV     CL,27           ; Start row
        MOV     DH,19           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000110B    ; Color = brown
        CALL    COARSE_FILL
;
; Display black bit map for scope
        LEA     SI,SCOPE_MAP1   ; Offset of bit map
        LEA     BX,BLACK        ; Color
        CALL    SHOW_BIT_MAP
; Display red bit map for scope
        LEA     SI,SCOPE_MAP2   ; Offset of bit map
        LEA     BX,RED          ; Color
        CALL    SHOW_BIT_MAP
; Display ammunition box
        LEA     SI,AMMO_MAP1    ; Offset of bit map
        LEA     BX,BLACK        ; Color
        CALL    SHOW_BIT_MAP
        LEA     SI,AMMO_MAP2    ; Offset of bit map
        LEA     BX,GREEN        ; Color
        CALL    SHOW_BIT_MAP
        LEA     SI,AMMO_MAP3    ; Offset of bit map
        LEA     BX,YELLOW       ; Color
        CALL    SHOW_BIT_MAP
;
        CALL    DATA_XOR
        RET
;
SCOPE_OFF       ENDP
;******************************************************************
;
VRI_ON  PROC    NEAR
; Installation of a vertical retrace interrupt handler
; The following code enables the vertical retrace interrupt on
; a VGA system and intercepts INT 0AH (IRQ2 vector)
; The code assumes a VGA system that supports the vertical
; retrace interrupt. Note that the VGA Adapter Card does not
; support this interrupt
;
; On entry:
;         DI holds offset of the interrupt service routine in the
;         current code segment
;
        PUSH    DI              ; Save offset of service routine
;**********************|
;    save parameters   |
;**********************|
; System port address is saved in CS variables so that they
; can be accessed by the main program and by the service routine
        CLI                     ; Interrupts off
        MOV     AX,0H           ; Clear AX
        MOV     ES,AX           ; and ES
        MOV     BX,0463H        ; BIOS data
        MOV     DX,WORD PTR ES:[BX]
                                ; Get CRT controller base address
                                ; from BIOS data area
        MOV     CS:CRT_PORT,DX  ; Save address in memory variable
        MOV     AL,11H          ; Offset of vertical retrace end
                                ; register in the CRTC
        OUT     DX,AL           ; Select this register
        JMP     SHORT $+2       ; I/O delay
; Value stored in port's data register is also saved
        INC     DX              ; Point to data register
        IN      AL,DX           ; Read default value in register
        JMP     SHORT $+2       ; I/O delay
        MOV     CS:OLD_VRE,AL   ; Save value in variable
;**********************|
;   save old INT 0AH   |
;**********************|
; Uses DOS service 53 of INT 21H to obtain original vector for
; INT 0AH from the vector table.
        MOV     AH,53           ; Service request number
        MOV     AL,0AH          ; Code of vector desired
        INT     21H
; ES --> Segment address of installed interrupt handler
; BX --> Offset address of installed interrupt handler
        LEA     SI,CS:OLD_VECTOR_0A
; Offset of forward pointer in 16-byte structured table
        MOV     CS:[SI],BX      ; Save offset of original handler
        MOV     CS:[SI+2],ES    ; and segment
;**********************|
; install this INT 0AH |
;        handler       |
;**********************|
; Using DOS service 37 of INT 21H
        POP     DX              ; Offset of service routine
        MOV     AH,37           ; Service request number
        MOV     AL,0AH          ; Interrupt code
        PUSH    DS              ; Save data segment
        PUSH    CS
        POP     DS              ; Set DS to CS for DOS service
        INT     21H
        POP     DS              ; Restore local data
;**********************|
;    enable IRQ2       |
;**********************|
; Clear bit 2 of the 8259 mask register
        CLI                     ; Make sure interrupts are off
        MOV     DX,21H          ; Port address of 8259 mask register
        IN      AL,DX           ; Read byte at port
        JMP     SHORT $+2       ; I/O delay
        AND     AL,11111011B    ; Mask for bit 2
        OUT     DX,AL           ; Back to 8259 port
        JMP     SHORT $+2       ; I/O delay
;**********************|
;  activate vertical   |
;  retrace interrupt   |
;**********************|
        MOV     DX,CS:CRT_PORT  ; Recover CRT base address
        MOV     AL,11H          ; Offset of vertical retrace end
                                ; register in the CRTC
        MOV     AH,CS:OLD_VRE   ; Default value in vertical retrace
                                ; end register
        AND     AH,11001111B    ; Clear bits 4 and 5 in VRE register
                                ; Bit 4 = clear vertical interrupt
                                ; Bit 5 = enable vertical retrace
        OUT     DX,AX           ; To port
        JMP     SHORT $+2       ; I/O delay
        OR      AH,00010000B    ; Mask to set bit 4 to re-enable
        OUT     DX,AX
        JMP     SHORT $+2       ; I/O delay
        STI                     ; Enable interrupts
        RET
VRI_ON  ENDP
;*****************************************************************
;
VRI_OFF PROC    NEAR
; The following code restores normal CRT operation. Processing
; consists of the following steps:
;   1. Restore default value in the vertical retrace end register
;   2. Restore original handler for INT 0AH
;
        CLI                     ; Interrupts off
;**********************|
;   disable vertical   |
;      interrupts      |
;**********************|
        PUSH    DS              ; Save data segment
        MOV     DX,CS:CRT_PORT  ; Recover CRT base address
        MOV     AL,11H          ; Offset of vertical retrace end
                                ; register in the CRTC
        MOV     AH,CS:OLD_VRE   ; Default value in vertical retrace
                                ; end register
                                ; Bit 5 = enable vertical retrace
        OUT     DX,AX           ; To port
        JMP     SHORT $+2       ; I/O delay
;**********************|
;   restore INT 0AH    |
;**********************|
        LEA     SI,CS:OLD_VECTOR_0A
; Set DS:DX to original segment and offset of keyboard interrupt
; vector
        MOV     DX,CS:[SI]      ; DX --> offset
        MOV     AX,CS:[SI+2]    ; AX --> segment
        MOV     DS,AX           ; segment to DS
        MOV     AH,25H          ; DOS service request
        MOV     AL,0AH          ; IRQ2
        INT     21H
;
        STI                     ; Interrupts on
        POP     DS              ; Restore data segment
        RET
VRI_OFF ENDP
;
;*******************************************************************
MOUSE_BUT       PROC    FAR
; This handler receives control when the left mouse button is
; pressed
;**********************|
;     save context     |
;**********************|
        PUSH    AX              ; Save operational registers
        PUSH    BX
        PUSH    CX
        PUSH    DX
;**********************|
; test for laoded gun  |
;**********************|
        CMP     BYTE PTR CS:GUN_LOADED,0        ; Gun is unloaded
        JNE     LOADED          ; Go if loaded
        JMP     EXIT_FIRED
LOADED:
        MOV     CS:GUN_LOADED,0         ; Set unloaded state
        MOV     CS:GUN_FIRED,1          ; Gun was fired switch
        MOV     CS:X_VALUE,0            ; Clear score variables
        MOV     CS:Y_VALUE,0
;***********************|
;   determine direction |
;***********************|
; If CS:ACTIVE_BOAR = 'R' then use coordinates for the right
; starting pig. If not, use coordinates of the left starting
; pig
        CMP     CS:ACTIVE_BOAR,'R'      ; Right pig
        JNE     L_ACTIVE        ; Use right pig parameters
        JMP     R_ACTIVE
; At this point left pig coordinates are used
L_ACTIVE:
        MOV     AX,CS:CROSS_X   ; Cross hair x coordinate
; Target center is 21 pixels left from pig's coordinate axis
        SUB     AX,21           ; Adjust to pig's axis
        ADD     AX,ON_X         ; To make range positive
        MOV     BX,CS:LPIG_X    ; Boar's x coordinate when gun fired
        MOV     DX,CS:LPIG_Y    ; Boar's y coordinate when gun fired
        JMP     EITHER_PIG
R_ACTIVE:
; On-target condition depends on equates ON_Y and ON_X
        MOV     AX,CS:CROSS_X   ; Cross hair x coordinate
; Target center is 12 pixels right from pig's coordinate axis
        SUB     AX,12           ; Adjust to pig's axis
        ADD     AX,ON_X         ; To make range positive
; AX now holds maximum boar x coordinate for on-target condition
; Minimum boar x coordinate is BX - (2 * ON_X)
        MOV     BX,CS:RPIG_X    ; Boar's x coordinate when gun fired
        MOV     DX,CS:RPIG_Y    ; Boar's y coordinate when gun fired
;***********************|
;  target arithemtic    |
;    for right pig      |
;***********************|
EITHER_PIG:
        SUB     AX,BX           ; Subtract to get AX - BX
; Valid range of AX for on-target is 0 to (2 * ON_X)
        JNC     TEST_X_RIGHT    ; Go if not negative
        JMP     NO_TARGET       ; No target if AX > BX
TEST_X_RIGHT:
; Test for right-hand limit of bullseye
; AX < (2 * ON_X)
        MOV     BX,ON_X         ; Load constant into BL
        ADD     BL,BL           ; Double it
        MOV     BH,0            ; Clear high element
        CMP     AX,BX           ; AX must be smaller
        JNC     NO_TARGET
;**********************|
;   test y coordinate  |
;     for on-target    |
;**********************|
        MOV     CS:X_VALUE,AL   ; Store x coordinate
        MOV     AX,CS:CROSS_Y   ; Cross hair y coordinate
        MOV     BX,DX           ; DX holds pig's y coordinate
; Target center is on axis with the pig's coordinates
        ADD     AX,ON_X         ; To make range positive
; AX now holds maximum boar y coordinate for on-target condition
; Minimum boar x coordinate is BX - (2 * ON_X)
        SUB     AX,BX           ; Subtract to get AX - BX
; Valid range of AX for on-target is 0 to (2 * ON_X)
        JNC     TEST_Y_DOWN     ; Go if not negative
        JMP     NO_TARGET       ; No target if AX > BX
TEST_Y_DOWN:
; AX < (2 * ON_X)
        MOV     BX,ON_X         ; Load constant into BL
        ADD     BL,BL           ; Double it
        MOV     BH,0            ; Clear high element
        CMP     AX,BX           ; AX must be smaller
        JNC     NO_TARGET
        MOV     CS:Y_VALUE,AL   ; Store y coordinate
;
        JMP     SOUND_HIT
;**********************|
;         hit          |
;**********************|
SOUND_HIT:
; Produce high frequency sound to indicate hit
        MOV     BX,3000         ; 3000 Hz frequency
        MOV     CX,80           ; 30 milliseconds duration
        CALL    SOUND           ; Procedure from SOLUTION.LIB
        MOV     CS:HIT_SW,1     ; Set switch for hit
        JMP     EXIT_FIRED
;**********************|
;        miss          |
;**********************|
; Produce a low frequency, shorter sound to indicate miss
NO_TARGET:
        MOV     CS:HIT_SW,0     ; Set for missed
        MOV     BX,600          ; 600 Hz frequency
        MOV     CX,20           ; 20 milliseconds duration
        CALL    SOUND           ; Procedure from SOLUTION.LIB
EXIT_FIRED:
        POP     DX
        POP     CX
        POP     BX
        POP     AX
        RET
MOUSE_BUT       ENDP
;
CODE_1  ENDS
        END

        POP     CX
        POP     BX
        POP     AX
        RET
MOUSE_BUT       ENDP
;
CODE_1  E